%define patchlevel 020
%define upstreamversion 1.1.1
%define tarballversion 1.10

Summary: A Japanese character set conversion system.
Name: FreeWnn
Version: %{tarballversion}pl%{patchlevel}
Release: 5
Epoch: 1
Group: Applications/System
License: Distributable
URL: http://www.freewnn.org/
Source0: ftp://ftp.freewnn.org/pub/FreeWnn/alpha/%{name}-%{upstreamversion}-a%{patchlevel}.tar.bz2
Source1: FreeWnn.init
Patch0: FreeWnn-fsstnd.patch
Patch1: FreeWnn-ja-a017.patch
Patch2: FreeWnn-install-chown.patch
Patch4: jserverrc-g-jinmei.patch
## patch for ia64
#Patch5: FreeWnn-ia64.patch
#Patch6: FreeWnn-shared.patch
Patch7: FreeWnn-reuid.patch
Patch8: FreeWnn-fPIC.patch
Patch9: FreeWnn-nosbit.patch
#Patch10: FreeWnn-dirlimit.patch
#Patch11: FreeWnn-nonstrip.patch
#Patch12: FreeWnn-1.1.1-unix.patch
Patch13: FreeWnn-jlib-js-arraybounds-80669.patch
Patch14: FreeWnn-1.1.1-fork-61907.patch
#Patch15: FreeWnn-1.1.1-a017-jutils-shlib-89068.patch
Patch16: FreeWnn-1.1.1-a020-wnntouch.patch
Patch17: FreeWnn-pod-searchdesc-args-110750.patch
Patch18: FreeWnn-1.10-smpmake.patch
Patch19: FreeWnn-1.10-pl020-jserver-64bit-128387.patch
Prereq: /sbin/chkconfig, grep, textutils, shadow-utils
Requires: chkconfig
Conflicts: wnn6
Obsoletes: FreeWnn-common
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: ncurses-devel

%description
FreeWnn is a network-extensible system for converting Japanese Kana to
Kanji characters.

%package devel
Summary: Development library and header files for FreeWnn.
Group: Development/Libraries
Requires: FreeWnn-libs = %{epoch}:%{version}-%{release}

%description devel
The FreeWnn-devel package contains files needed for building programs
which will use the FreeWnn Kana-to-Kanji conversion system.

%package libs
Summary: A runtime library for FreeWnn.
Group: System Environment/Libraries

%description libs
The FreeWnn-libs package contains the runtime library for running
programs with the FreeWnn Kana-to-Kanji conversion system.

%define wnnuser wnn
%define wnnuid 49
%define wnngrp wnn
%define wnngid 49
%define wnndir %{_localstatedir}/lib/wnn

%prep
%setup -q -n %{name}-%{tarballversion}-pl%{patchlevel}
%patch0 -p2
%patch1 -p2
%patch2 -p1
%patch4 -p2
#%%patch5 -p2 -b .ia64
#%%patch6 -p2 -b .shlib
%patch7 -p1 -b .reuid
%patch8 -p1 -b .fPIC
%patch9 -p1 -b .nosbit
#%%patch10 -p2 -b .dl
#%%patch11 -p2 -b .nonstrip
#%%patch12 -p1 -b .unix
%patch13 -p2 -b .bounds
%patch14 -p1 -b .fork
#%%patch15 -p2 -b .static
%patch16 -p1 -b .wnntouch
%patch17 -p1 -b .args
%patch18 -p1 -b .smpmake
%patch19 -p1 -b .64bit

%build
%configure --disable-cWnn --disable-kWnn

# -D_XOPEN_SOURCE is needed to get the crypt() prototype properly for Wnn/etc/pwd.c
%{__make} %{?_smp_mflags} CDEBUGFLAGS="$RPM_OPT_FLAGS -D_XOPEN_SOURCE" ALLLANGDEF=-DJAPANESE

%install
%{__rm} -rf $RPM_BUILD_ROOT

# don't strip, don't set owner
make DESTDIR=$RPM_BUILD_ROOT INSTPGMFLAGS= INSTALLFLAGS='-m755' LOCAL_INSTFLAGS= install install.man

%{__mkdir_p} $RPM_BUILD_ROOT/%{_mandir}/ja/man1
%{__mkdir_p} $RPM_BUILD_ROOT/%{_mandir}/ja/man3
%{__mkdir_p} $RPM_BUILD_ROOT/%{_mandir}/ja/man4
%{__mkdir_p} $RPM_BUILD_ROOT/%{_mandir}/ja/man5
cd $RPM_BUILD_ROOT/%{_mandir}/man1
mv *.1 $RPM_BUILD_ROOT/%{_mandir}/ja/man1/

cd $RPM_BUILD_ROOT/%{_mandir}/man3
mv *.3 $RPM_BUILD_ROOT/%{_mandir}/ja/man3/

cd $RPM_BUILD_ROOT/%{_mandir}/man4
mv *.4 $RPM_BUILD_ROOT/%{_mandir}/ja/man4/

cd $RPM_BUILD_ROOT/%{_mandir}/man5
mv *.5 $RPM_BUILD_ROOT/%{_mandir}/ja/man5/

## convert to UTF-8
for i in `find $RPM_BUILD_ROOT%{_mandir}/ja -type f`; do
	iconv -f euc-jp -t utf-8 $i > $i.new && mv -f $i.new $i && chmod 444 $i
done

%{__mkdir_p} ${RPM_BUILD_ROOT}/etc/rc.d/init.d
%{__install} -m755 %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/FreeWnn
ln -sf %{wnndir}/ja/dic ${RPM_BUILD_ROOT}/etc/FreeWnn/ja/dic

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# make sure the user and group exist and have the correct values
if grep -q "^%{wnngrp}:" /etc/group 2> /dev/null ; then
  /usr/sbin/groupmod -g %{wnngid} -n %{wnngrp} %{wnngrp} 2> /dev/null || :
else
  /usr/sbin/groupadd -g %{wnngid} %{wnngrp} 2> /dev/null || :
fi
if grep -q "^%{wnnuser}:" /etc/passwd 2> /dev/null ; then
  /usr/sbin/usermod -s /sbin/nologin -c "GNU Mailing List Manager" -d %{wnndir} -u %{wnnuid} -g %{wnngid} %{wnnuser} 2> /dev/null || :
else
  /usr/sbin/useradd -s /sbin/nologin -c "Wnn Input Server" -d %{wnndir} -u %{wnnuid} -g %{wnngid} -M -r %{wnnuser} 2> /dev/null || :
fi

%post
/sbin/chkconfig --add FreeWnn
#/sbin/chkconfig --level 0123456 FreeWnn off
/usr/bin/wnntouch  %{wnndir}/ja/dic/{gerodic/g-jinmei.dic,pubdic/*.*}

%preun
if [ "$1" = "0" ]; then
    /sbin/service FreeWnn stop > /dev/null 2>&1 || :
    /sbin/chkconfig --del FreeWnn
fi

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service FreeWnn condrestart >/dev/null 2>&1 || :
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files
%defattr(-,root,root)
%dir %{wnndir}
%dir %{wnndir}/ja
%doc CONTRIBUTORS COPYRIGHT* ChangeLog Wnn/manual Wnn/manual.en
%config /etc/rc.d/init.d/FreeWnn
%attr(-,%{wnnuser},root) %{_bindir}/atod
%attr(-,%{wnnuser},root) %{_bindir}/dtoa
%attr(-,%{wnnuser},root) %{_bindir}/oldatonewa
%attr(-,%{wnnuser},root) %{_bindir}/wdreg
%attr(-,%{wnnuser},root) %{_bindir}/wnnstat
%attr(-,%{wnnuser},root) %{_bindir}/atof
%attr(711,%{wnnuser},root) %{_bindir}/jserver
%attr(-,%{wnnuser},root) %{_bindir}/wddel
%attr(-,%{wnnuser},root) %{_bindir}/wnnkill
%attr(-,%{wnnuser},root) %{_bindir}/wnntouch
%{_mandir}/ja/man1/*
%{_mandir}/ja/man4/*
%{_mandir}/ja/man5/*
%attr(-,%{wnnuser},root) %{wnndir}/ja/dic
%dir /etc/FreeWnn
%config /etc/FreeWnn/cvt_key_empty
%config /etc/FreeWnn/cvt_key_tbl
%config /etc/FreeWnn/cvt_key_tbl.ST
%config /etc/FreeWnn/cvt_key_tbl.gm
%config /etc/FreeWnn/cvt_key_tbl.kt
%config /etc/FreeWnn/cvt_key_tbl.mv
%config /etc/FreeWnn/cvt_key_tbl.vt
%dir /etc/FreeWnn/ja
/etc/FreeWnn/ja/dic
%config /etc/FreeWnn/ja/hinsi.data
%config /etc/FreeWnn/ja/jserverrc
%config /etc/FreeWnn/ja/libwnn.msg
%config /etc/FreeWnn/ja/rk
%config /etc/FreeWnn/ja/rk.vi
%config /etc/FreeWnn/ja/uum.msg
%config /etc/FreeWnn/ja/uumkey
%config /etc/FreeWnn/ja/uumkey.omr
%config /etc/FreeWnn/ja/uumkey_e
%config /etc/FreeWnn/ja/uumrc
%config /etc/FreeWnn/ja/uumrc.omr
%config /etc/FreeWnn/ja/uumrc.rev
%config /etc/FreeWnn/ja/uumrc_e
%config /etc/FreeWnn/ja/uumrc_vi
%config /etc/FreeWnn/ja/wnnenvrc
%config /etc/FreeWnn/ja/wnnenvrc.omr
%config /etc/FreeWnn/ja/wnnenvrc.rem
%config /etc/FreeWnn/ja/wnnenvrc.rev
%config /etc/FreeWnn/ja/wnnenvrc_R
%config /etc/FreeWnn/ja/wnnenvrc_R.omr
%config /etc/FreeWnn/ja/wnnenvrc_R.rem
%config /etc/FreeWnn/ja/wnnstat.msg
%dir /etc/FreeWnn/lt_LN
/etc/FreeWnn/lt_LN/rk
%config /etc/FreeWnn/lt_LN/uum.msg
%config /etc/FreeWnn/lt_LN/uumkey
%config /etc/FreeWnn/lt_LN/uumkey_e
%config /etc/FreeWnn/lt_LN/uumrc
%config /etc/FreeWnn/serverdefs

%files devel
%defattr(-,root,root)
%dir %{_includedir}/wnn
%{_includedir}/wnn/*
%{_libdir}/libjd.a
%{_libdir}/libjd.la
%{_libdir}/libjd.so
%{_libdir}/libwnn.a
%{_libdir}/libwnn.la
%{_libdir}/libwnn.so
%{_mandir}/ja/man3/*

%files libs
%defattr(-,root,root)
%{_libdir}/libjd.so.0
%attr(755,root,root) %{_libdir}/libjd.so.0.0.0
%{_libdir}/libwnn.so.0
%attr(755,root,root) %{_libdir}/libwnn.so.0.0.0

%changelog
* Fri Oct 29 2004 Jens Petersen <petersen@redhat.com> - 1:1.10pl020-5
- before upgrading modify the wnn user and group (in the same way mailman does)
  rather than deleting and recreating them to really fix the upgrade failure
  with nis (136551)
  - simplify this by introducing %%wnnuser, %%wnnuid, %%wnngrp, %%wnngid and
    %%wnndir and use them

* Wed Oct 27 2004 Jens Petersen <petersen@redhat.com> - 1:1.10pl020-4
- make sure any stray wnn group is removed before adding wnn user when
  installing or upgrading (136551)

* Mon Aug  9 2004 Jens Petersen <petersen@redhat.com> - 1:1.10pl020-3
- add FreeWnn-1.10-pl020-jserver-64bit-128387.patch to fix a couple of problems
  with jserver on 64bit archs (Neil Horman, 128387)
- check right subsys lock file when doing condrestart in init.d script
- improve description
- include copyright files in docs

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com> - 1:1.10pl020-2
- add FreeWnn-1.10-smpmake.patch to enable smp build
- use $RPM_OPT_FLAGS and define _XOPEN_SOURCE for build
- fix install permissions

* Tue Mar 23 2004 Jens Petersen <petersen@redhat.com> - 1:1.10pl020-1
- update to pl020
  - adjust version number correctly and set epoch to 1
  - replace FreeWnn-noroot.patch and FreeWnn-noroot2.patch with
    FreeWnn-install-chown.patch, FreeWnn-1.1.1-a020-wnntouch.patch and
    unset LOCAL_INSTFLAGS during install
  - no longer need FreeWnn-1.1.1-unix.patch since there is -u option now
  - no longer need FreeWnn-dirlimit.patch, FreeWnn-ia64.patch,
    FreeWnn-shared.patch and FreeWnn-1.1.1-a017-jutils-shlib-89068.patch
  - update FreeWnn-fPIC.patch, FreeWnn-reuid.patch
  - update and rename FreeWnn-1.1.1-fix-x86-64-61907.patch to
    FreeWnn-1.1.1-fork-61907.patch
  - replace FreeWnn-nonstrip.patch with install makefile variable setting
  - pl020 fixes casting in initjserv.c (d.binderman,#113801)
- don't start FreeWnn jserver by default any more for new installs
- add condrestart command to init script and use it in %%postun
- only chkconfig --del if erasing package
- merge FreeWnn-common into main FreeWnn package, make it obsoleted and update
  description
- remove the disabled cWnn, kWnn and tWnn subpackages from the spec file
- disable cWnn and kWnn with configure options instead
- build without smp and -DJAPANESE only
- fix wnn's home dir and no need to add wnn4 to /etc/services (notting,#118651)
- simplify manpage installation
- add FreeWnn-pod-searchdesc-args-110750.patch to fix args of searchdesc in
  pod.c (d.binderman,#110750)

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Dec 16 2003 Jens Petersen <petersen@redhat.com> - 1.11-41
- add FreeWnn-1.1.1-a017-jutils-shlib-89068.patch to link utilities
  against libwnn.so (#89068) [reported by Jeremy Katz]
- FreeWnn now requires FreeWnn-libs

* Thu Dec  4 2003 Jens Petersen <petersen@redhat.com> - 1.11-40
- apply FreeWnn-1.1.1-fix-x86-64-61907.patch (#61907) [Akira Tagoh]
- make shared library executable [Florian Laroche]

* Tue Oct 28 2003 Jens Petersen <petersen@redhat.com> - 1.11-39
- exit init.d script with actual return value

* Tue Sep 30 2003 Akira TAGOH <tagoh@redhat.com> 1.11-38
- converted Japanese manpages to UTF-8.

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu May 15 2003 Elliot Lee 1.11-36
- Rebuild

* Mon Apr 21 2003 Jens Petersen <petersen@redhat.com> - 1.11-35
- fix array bounds in jlib/js.c (#80669) [patch from d.binderman@virgin.net]
- make FreeWnn-devel require FreeWnn-libs (#52351)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Sat Dec 21 2002 Yukihiro Nakai <ynakai@redhat.com>
- Change login shell to /sbin/nologin (#80167)

* Mon Dec 16 2002 Yukihiro Nakai <ynakai@redhat.com>
- extract *bz2 patches
- Define AF_UNIX
- Remove PF_INET code from jserver
- Set FreeWnn on by default

* Thu Dec 12 2002 Yukihiro Nakai <ynakai@redhat.com>
- ctkWnn off

* Wed Nov 20 2002 Tim Powers <timp@redhat.com>
- rebuild for all arches

* Fri Aug 23 2002 Yukihiro Nakai <ynakai@redhat.com> 1.11-27
- Set FreeWnn server off by default. (#69119)
- Add cwnntouch to %%files

* Thu Jul 18 2002 Akira TAGOH <tagoh@redhat.com> 1.11-26
- add some owned directory.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun 19 2002 Akira TAGOH <tagoh@redhat.com> 1.11-24
- FreeWnn-nonstrip.patch: applied to fix the stripped binary.
- s/Copyright/License/

* Wed Jun 05 2002 Yukihiro Nakai <ynakai@redhat.com>
- Remove warning message. (#65781)

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sat Jan 26 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- add further Prereq: /sbin/chkconfig to subpackages

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Aug 27 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add patch to set limit the wnn user directory.

* Tue Aug 14 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add nosbit patch
- Change *server mode 4711 -> 711

* Mon Jul 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add ncurses-devel to BuildPrereq. (#44720)
- Add chkconfig to reduce build errors.

* Mon Jul  9 2001 Matt Wilson <msw@redhat.com>
- disable cWnn, tWnn, kWnn and their subpackages
- re-enable [ctk]Wnn

* Tue Feb  6 2001 Matt Wilson <msw@redhat.com>
- added Prereq: /sbin/chkconfig to main package
- added Prereqs for common subpackage

* Mon Jan 29 2001 Trond Eivind Glomsrd <teg@redhat.com>
- new init style (no gprintf)

* Wed Jan 24 2001 Adrian Havill <havill@redhat.com>
- fixed useradd to be consistent with other useradd pkg behavior
- changed default uid/gid to match internal RH allocation

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add post and postun for -devel, -libs
- More fix about grep command.
- defattr added.
- Add -fPIC patch for IA64
- Update FreeWnn.init, cWnn.init, kWnn.init, tWnn.init
  to suppport RH color'ed

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- secured so both EUID and RUID are set (havill@redhat.com)

* Mon Jan 22 2001 Yukihiro Nakai <ynakai@redhat.com>
- Split the runtime libraries.
- Build libwnn.so
- bzip2

* Sat Dec 19 2000 Satoru Sato <ssato@redhat.com>
- fix SPEC

* Sat Dec 09 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add ia64 patch.

* Thu Sep 13 2000 Satoru Sato <ssato@redhat.com>
- (c|k|t)Wnn daemon are not started by default.

* Thu Sep  7 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- initfile move back /etc/init.d -> /etc/rc.d/init.d

* Fri Aug  4 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- move /etc/rc.d/init.d -> /etc/init.d

* Fri Aug  4 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- ported from Vine Linux
- Built for RedHat 7.0

* Tue Jul 25 2000 Lisa Sagami <czs14350@mb.infoweb.ne.jp>
- changed: each package (except devel) owns /etc/FreeWnn/* by adding %dir
- modified again *.init to do with socket left in /tmp 

* Fri Jul 14 2000 Lisa Sagami <czs14350@nifty.ne.jp>
- add %pre to addusr 127/wnn to avoid non-root build failure
- modified *.init to do with socket left in /tmp 
- correct %doc

* Tue Jul 11 2000 Masato Bito <masato@nets.ce.hiroshima-cu.ac.jp>
- 1.1.1-1vl3
- modified %patch0 -p3 -> %patch0 -p2
- modified BuildRoot:

* Thu Jul  6 2000 Jun Nishii <jun@vinelinux.org>
- 1.1.1-1vl2
- fix bug in FreeWnn-ja-a017.patch

* Wed Jul  5 2000 Jun Nishii <jun@vinelinux.org>
- 1.1.1-1vl1
- handle man page compress
- update to FreeWnn-1.1.1-a017

* Mon Jan 31 2000 Norihito Ohmori <nono@kondara.org>
- ja_JP -> ja
- configuration file move to /etc
- change group.
- add cWnn and kWnn.
- add FreeWnn-common Package.
- remove sample.eggrc

* Tue Jan 25 2000 Norihito Ohmori <nono@vinelinux.org>
- add defattr and attr for %files section

* Tue Nov 23 1999 Norihito Ohmori <ohmori@flatout.org>
- add Requires: chkconfig
- Conflicts change from Wnn6 to wnn6

* Fri Nov 12 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
- FreeWnn-1.1.1-0.a013.4
- added Prereq: grep,textutils

* Wed Nov 10 1999 Jun Nishii <jun@flatout.org>
- remove cWnn and kWnn

* Sun Nov  7 1999 Yasuhide OOMORI <dasen@typhoon.co.jp>
- [FreeWnn-1.1.1-0.a013.2]
- Added a sample file of .eggrc to utilize gerodic.
- Now do not ldconfig after installation of FreeWnn-devel.
- Enabled you to compile with multi processors.
- Added 'Prereq: shadow-utils' for installation.
- Modified FreeWnn-jserver.script against error at boot time.

* Wed Oct 20 1999 Yasuhide OOMORI <dasen@typhoon.co.jp>
- [FreeWnn-1.1.1-0.a013.1]
- Updated to FreeWnn-1.1.1-a013.
- Separated cWnn,kWnn packages again.
- Make this package relocatable.
- Keep jserverrc and wnnenvrc when upgrading.

* Fri Sep 24 1999 Masaru Yokoi <yokoi @yk.fks.ryukoku.ac.jp>
- [FreeWnn-1.10-3]
- Added /var/lib/wnn/*/dic/usr .
- Moved libwnn.a from FreeWnn package to FreeWnn-devel package.
- Moved Japanese manuals from /usr/X11R6/man/man*
- to /usr/X11R6/man/ja_JP.ujis/man* .

* Wed Aug 11 1999 Masaru Yokoi <yokoi@yk.fks.ryukoku.ac.jp>
- First release.  Original idea is Sat Jul 12 1999 Norihito Ohmori
- <ohmori@flatout.org>

